(function (root, factory) {
  if (typeof define === 'function' && define.amd)
    define(['exports', 'kotlin', 'kotlinx-coroutines-core'], factory);
  else if (typeof exports === 'object')
    factory(module.exports, require('kotlin'), require('kotlinx-coroutines-core'));
  else {
    if (typeof kotlin === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-test-dispatcher-js-legacy'. Its dependency 'kotlin' was not found. Please, check whether 'kotlin' is loaded prior to 'ktor-ktor-test-dispatcher-js-legacy'.");
    }
    if (typeof this['kotlinx-coroutines-core'] === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-test-dispatcher-js-legacy'. Its dependency 'kotlinx-coroutines-core' was not found. Please, check whether 'kotlinx-coroutines-core' is loaded prior to 'ktor-ktor-test-dispatcher-js-legacy'.");
    }
    root['ktor-ktor-test-dispatcher-js-legacy'] = factory(typeof this['ktor-ktor-test-dispatcher-js-legacy'] === 'undefined' ? {} : this['ktor-ktor-test-dispatcher-js-legacy'], kotlin, this['kotlinx-coroutines-core']);
  }
}(this, function (_, Kotlin, $module$kotlinx_coroutines_core) {
  'use strict';
  var coroutines = Kotlin.kotlin.coroutines;
  var L60000 = Kotlin.Long.fromInt(60000);
  var coroutines_0 = $module$kotlinx_coroutines_core.kotlinx.coroutines;
  var withTimeout = $module$kotlinx_coroutines_core.kotlinx.coroutines.withTimeout_ms3uf5$;
  var COROUTINE_SUSPENDED = Kotlin.kotlin.coroutines.intrinsics.COROUTINE_SUSPENDED;
  var CoroutineImpl = Kotlin.kotlin.coroutines.CoroutineImpl;
  var promise = $module$kotlinx_coroutines_core.kotlinx.coroutines.promise_pda6u4$;
  function Coroutine$testSuspend$lambda(closure$timeoutMillis_0, closure$block_0, $receiver_0, controller, continuation_0) {
    CoroutineImpl.call(this, continuation_0);
    this.$controller = controller;
    this.exceptionState_0 = 1;
    this.local$closure$timeoutMillis = closure$timeoutMillis_0;
    this.local$closure$block = closure$block_0;
  }
  Coroutine$testSuspend$lambda.$metadata$ = {
    kind: Kotlin.Kind.CLASS,
    simpleName: null,
    interfaces: [CoroutineImpl]
  };
  Coroutine$testSuspend$lambda.prototype = Object.create(CoroutineImpl.prototype);
  Coroutine$testSuspend$lambda.prototype.constructor = Coroutine$testSuspend$lambda;
  Coroutine$testSuspend$lambda.prototype.doResume = function () {
    do
      try {
        switch (this.state_0) {
          case 0:
            this.state_0 = 2;
            this.result_0 = withTimeout(this.local$closure$timeoutMillis, this.local$closure$block, this);
            if (this.result_0 === COROUTINE_SUSPENDED)
              return COROUTINE_SUSPENDED;
            continue;
          case 1:
            throw this.exception_0;
          case 2:
            return this.result_0;
          default:
            this.state_0 = 1;
            throw new Error('State Machine Unreachable execution');
        }
      } catch (e) {
        if (this.state_0 === 1) {
          this.exceptionState_0 = this.state_0;
          throw e;
        } else {
          this.state_0 = this.exceptionState_0;
          this.exception_0 = e;
        }
      }
     while (true);
  };
  function testSuspend$lambda(closure$timeoutMillis_0, closure$block_0) {
    return function ($receiver_0, continuation_0, suspended) {
      var instance = new Coroutine$testSuspend$lambda(closure$timeoutMillis_0, closure$block_0, $receiver_0, this, continuation_0);
      if (suspended)
        return instance;
      else
        return instance.doResume(null);
    };
  }
  function testSuspend(context, timeoutMillis, block) {
    if (context === void 0)
      context = coroutines.EmptyCoroutineContext;
    if (timeoutMillis === void 0)
      timeoutMillis = L60000;
    return promise(coroutines_0.GlobalScope, context, void 0, testSuspend$lambda(timeoutMillis, block));
  }
  var package$io = _.io || (_.io = {});
  var package$ktor = package$io.ktor || (package$io.ktor = {});
  var package$test = package$ktor.test || (package$ktor.test = {});
  var package$dispatcher = package$test.dispatcher || (package$test.dispatcher = {});
  package$dispatcher.testSuspend_rngysb$ = testSuspend;
  Kotlin.defineModule('ktor-ktor-test-dispatcher-js-legacy', _);
  return _;
}));

//# sourceMappingURL=ktor-ktor-test-dispatcher-js-legacy.js.map
